library matchable_builder;

// builder
export 'package:matchable_builder/src/matchable_builder.dart';

// base matcher
export 'package:matchable_builder/src/matcher/matcher.dart';

// general matchers
export 'package:matchable_builder/src/matcher/always_true_matcher.dart';
export 'package:matchable_builder/src/matcher/always_false_matcher.dart';

// build step matchers
export 'package:matchable_builder/src/matcher/filename_exact_extension_matcher.dart';
export 'package:matchable_builder/src/matcher/filename_extension_matcher.dart';
export 'package:matchable_builder/src/matcher/filename_matcher.dart';
export 'package:matchable_builder/src/matcher/filename_prefix_matcher.dart';
export 'package:matchable_builder/src/matcher/filename_suffix_matcher.dart';
export 'package:matchable_builder/src/matcher/functional_matcher.dart';
export 'package:matchable_builder/src/matcher/file_schema_matcher.dart';

// element matchers
export 'package:matchable_builder/src/matcher/element_annotation_matcher.dart';
export 'package:matchable_builder/src/matcher/element_type_matcher.dart';
export 'package:matchable_builder/src/matcher/element_name_matcher.dart';
export 'package:matchable_builder/src/matcher/element_name_prefix_matcher.dart';
export 'package:matchable_builder/src/matcher/element_name_suffix_matcher.dart';

// class element matchers
export 'package:matchable_builder/src/matcher/class_element_matcher.dart';
export 'package:matchable_builder/src/matcher/class_element_field_annotation_matcher.dart';
export 'package:matchable_builder/src/matcher/class_element_method_annotation_matcher.dart';
export 'package:matchable_builder/src/matcher/class_element_constructor_matcher.dart';
export 'package:matchable_builder/src/matcher/class_element_constructor_annotation_matcher.dart';
export 'package:matchable_builder/src/matcher/class_element_super_type_matcher.dart';
export 'package:matchable_builder/src/matcher/class_element_direct_super_type_matcher.dart';
export 'package:matchable_builder/src/matcher/class_element_assignable_from_matcher.dart';
export 'package:matchable_builder/src/matcher/class_element_interface_matcher.dart';

// cache related
export 'package:matchable_builder/src/support/matchable_combining_builder.dart';
export 'package:matchable_builder/src/cache/cache.dart';

// helpers
export 'package:matchable_builder/src/helper/cache_helper.dart';

// dependencies
export 'package:analyzer/dart/element/element.dart';
export 'package:analyzer/dart/element/type.dart';
